function [ out,S_all ] = monitoring(r,data_raw,mT,momfunc,B)
T=size(data_raw,1);
N=size(data_raw,2);
iniSeed1=r*333;
e0 = [T,N,iniSeed1,mT]; 
data=tiedrank(data_raw(1:mT,:))/(mT+1);
m_mT=feval(momfunc,data);
theta_mT=theta_t(data,e0)
[~,sim_data_raw]=datagen(T-mT,N,r,theta_mT,theta_mT,theta_mT);
sim_data_raw=[data_raw(1:mT,:);sim_data_raw];
sim_data=tiedrank(sim_data_raw)/(T+1);
%----------------Distribution----------------------------------------------

K=Bootstrap(sim_data_raw,momfunc);
m0=feval(momfunc,sim_data);
X=zeros(B,1);
parfor b=0:1:B-1  
    m=0;
    dataB_T=tiedrank(K((1+T*b):(mT+T*b),:))/(mT+1);
    mB_T=feval(momfunc,dataB_T);
    Am=(mT/T)*sqrt(T)*(mB_T-m0);  
    for t=1:T-mT
      dataB_t=tiedrank(K((1+t+T*b):(t+mT+T*b),:))/(mT+1);
      mB_t=feval(momfunc,dataB_t);
      A=(mT/T)*sqrt(T)*(mB_t-m0);
      A_star=(A-Am)'*(A-Am);
      if (A_star>m)
          m=A_star;
      end
    end
    X(b+1)=m;
end
c=quantile(X,0.95);
%----------------Test-statistic--------------------------------------------

x=2;
rej=0;
S_all=zeros(T-mT,1);
for t=1:T-mT
    raw_data_t=data_raw(1+t:mT+t,:);
    data_t=tiedrank(raw_data_t)/(mT+1);
    m_t=feval(momfunc,data_t);
    S=(mT/T)*(mT/T)*T*(m_t-m_mT)'*(m_t-m_mT);
     if (S>c)
         x=1;
         rej=t+mT;
         S_all(t,1)=S;  
         break;
     end
    S_all(t,1)=S;  
end

S=max(S_all);
out=[S,c,x,rej];


end

